/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookPostConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookPostConnectorForm{}

// FacebookPostConnectorForm struct for FacebookPostConnectorForm
type FacebookPostConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Label of the source
	Label string `json:"label"`
	// Facebook Page ID.
	PageId string `json:"pageId"`
	// Metrics
	Metric []string `json:"metric"`
	// Data labels
	DataLabel []string `json:"dataLabel"`
	// Max posts returned
	Limit int32 `json:"limit"`
}

// NewFacebookPostConnectorForm instantiates a new FacebookPostConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookPostConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, pageId string, metric []string, dataLabel []string, limit int32) *FacebookPostConnectorForm {
	this := FacebookPostConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.PageId = pageId
	this.Metric = metric
	this.DataLabel = dataLabel
	this.Limit = limit
	return &this
}

// NewFacebookPostConnectorFormWithDefaults instantiates a new FacebookPostConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookPostConnectorFormWithDefaults() *FacebookPostConnectorForm {
	this := FacebookPostConnectorForm{}
	var limit int32 = 100
	this.Limit = limit
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *FacebookPostConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *FacebookPostConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *FacebookPostConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *FacebookPostConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *FacebookPostConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *FacebookPostConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *FacebookPostConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *FacebookPostConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *FacebookPostConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *FacebookPostConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *FacebookPostConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *FacebookPostConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *FacebookPostConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetPageId returns the PageId field value
func (o *FacebookPostConnectorForm) GetPageId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetPageIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageId, true
}

// SetPageId sets field value
func (o *FacebookPostConnectorForm) SetPageId(v string) {
	o.PageId = v
}

// GetMetric returns the Metric field value
func (o *FacebookPostConnectorForm) GetMetric() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetMetricOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metric, true
}

// SetMetric sets field value
func (o *FacebookPostConnectorForm) SetMetric(v []string) {
	o.Metric = v
}

// GetDataLabel returns the DataLabel field value
func (o *FacebookPostConnectorForm) GetDataLabel() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetDataLabelOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DataLabel, true
}

// SetDataLabel sets field value
func (o *FacebookPostConnectorForm) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetLimit returns the Limit field value
func (o *FacebookPostConnectorForm) GetLimit() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Limit
}

// GetLimitOk returns a tuple with the Limit field value
// and a boolean to check if the value has been set.
func (o *FacebookPostConnectorForm) GetLimitOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Limit, true
}

// SetLimit sets field value
func (o *FacebookPostConnectorForm) SetLimit(v int32) {
	o.Limit = v
}

func (o FacebookPostConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookPostConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["pageId"] = o.PageId
	toSerialize["metric"] = o.Metric
	toSerialize["dataLabel"] = o.DataLabel
	toSerialize["limit"] = o.Limit
	return toSerialize, nil
}

type NullableFacebookPostConnectorForm struct {
	value *FacebookPostConnectorForm
	isSet bool
}

func (v NullableFacebookPostConnectorForm) Get() *FacebookPostConnectorForm {
	return v.value
}

func (v *NullableFacebookPostConnectorForm) Set(val *FacebookPostConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookPostConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookPostConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookPostConnectorForm(val *FacebookPostConnectorForm) *NullableFacebookPostConnectorForm {
	return &NullableFacebookPostConnectorForm{value: val, isSet: true}
}

func (v NullableFacebookPostConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookPostConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
